# This script starts/stops ipgrap and dumps its output to stdout.

set lock 0
set fid 0
set forever 0
set prompt ":-)"

# The nonewline prompts were hanging the server.  I took them out.
# put them back in if you are going to run stand alone.  Maybe,
# do it programatically?


#########################################################################
###### Procs
#########################################################################


proc GetIpGrabLine {fid} {

	if [eof $fid] {
		catch {close $fid}
		return
	}

    if {[gets $fid line] >= 0} {
		puts $line
    } 
	#check to see if I need the flush.

	flush stdout
}


proc CmdStartIt {parms} {

	global fid

	puts $parms
	set fid [open "| [list ipgrab -b -p $parms] " r]

	fileevent $fid readable "GetIpGrabLine $fid"
	fconfigure $fid -blocking 0
}

proc CmdStopIt {} {

	global fid

	catch {exec kill [pid $fid]}
	puts [pid $fid]
	set fid 0
}

proc CmdQuit {} {
	global fid
	if {$fid != 0} {
		CmdStopIt
	}
	exit
}

proc StdinRead {} {

	global command prompt parser
	if [eof stdin] {
		exit
	}

	append command(line) [gets stdin]

	if [info complete $command(line))] {
		if {[catch {$parser eval $command(line)} result] != 0} {
			puts "error: $result"
		}

		# do this programatically.
		#puts -nonewline $prompt
		flush stdout
		set command(line) {}
	}
}

#########################################################################
###### Initialization Code
#########################################################################



set parser [interp create -safe]

$parser eval {

}

$parser alias StartIt CmdStartIt
$parser alias StopIt CmdStopIt
$parser alias Quit CmdQuit



fileevent stdin readable StdinRead

# do this programatically.
#puts -nonewline $prompt
flush stdout

vwait forever

