# server.tcl - provides a socket interface for the grabber.tcl backend.

set forever 0

proc ReadGrabberPipe {fid} {
	global clientSocket

	#puts "ReadGrabberPipe"

	if [eof $fid] {
		puts "BackEnd closed1?"
		catch {close $fid}
		exit
	}

	# read from the pipe.
	gets $fid line
	# echo the line to the console.
	#puts "line read from grabber pipe: $line"
	# echo the line to the socket.
	puts $clientSocket $line


}

proc ServerSocketAccept {cid addr port} {
	global clientSocket
	global clientPort

	puts "socket accept. socket id = $cid"
	puts "socket accept. port id = $port"
	set clientSocket $cid
	set clientPort $port

	fileevent $cid readable "ReadClientSocket $cid"
	fconfigure $cid -buffering line
}

proc ReadClientSocket {cid} {

	global backend
	global clientPort

	#puts "ReadClientSocket"

	if {[eof $cid] || [catch {gets $cid line}]} {
		# eof or abnormal connection drop.
		close $cid
		puts "client closed."
	}


	# print to this stdout what was read from the socket.
	#puts "This was read from the socket: $line"
	# echo back to the socket.
	puts $cid "This was read from the socket: $line"

	# If its the quit routine, close the app.
	if {[string match "quit" $line]} {
		close $cid
		exit
	}
	if {[string match "StartIt*" $line]} {
		#puts "StartIt"
		#puts "The Line:$line:"
		regsub -- "\}" $line " and not port $clientPort and not port 9999\}" subVar
		set line $subVar
		puts "The Line:$line:"
	}

	# send the command to the backend pipe.
	puts $backend $line
}

set backend [open "| tclsh grabber.tcl" "r+"]
#fconfigure $backend -buffering line -blocking false
fconfigure $backend -buffering line 
fileevent $backend readable "ReadGrabberPipe $backend"

socket -server ServerSocketAccept 9999
vwait forever



