#
#  client.tcl - Tcl/Tk ui wrapper for network'd ipgrab demo.
#
#

policy home

# Make sure you have a line in your home.cfg file for the plugin 
# which looks like:
# allow $originSocketHost > 1024

set scrollLock 0

#####################################################################
###
###  UI Proc
###
#####################################################################
proc StartButton {} {


	#set foo [concat [.frFilter.eEntry get] and not port 9999 ]
	WriteSocket StartIt [.frFilter.eEntry get]
}

proc StopButton {} {

	WriteSocket StopIt
}
proc ClearButton {} {

	.frOutput.lListBox delete 0 end
}
#####################################################################
###
###  Creating the UI Elements
###
#####################################################################

frame .frOutput -relief sunken -borderwidth 1
frame .frFilter
frame .frControls -relief sunken -borderwidth 1

listbox .frOutput.lListBox -width 70 -height 12 -yscrollcommand {.frOutput.sSB set}
scrollbar .frOutput.sSB -orient vertical -command {.frOutput.lListBox yview}
entry .frFilter.eEntry
.frFilter.eEntry insert 0 "host davis.wg.com"
button .frControls.bStart -text "Start" -background #22dd00 \
	-command StartButton
button .frControls.bStop -text "Stop" -background #dd2200 \
	-command StopButton
button .frControls.bClear -text "Clear" -command ClearButton
checkbutton .frControls.bLock -text "Lock" -variable scrollLock

#####################################################################
###
###  Packing the UI Elements
###
#####################################################################

pack .frOutput.sSB -pady 4 -padx 4 -side right -fill y
pack .frOutput.lListBox -pady 4 -padx 4 -side left -fill both -expand yes
pack .frFilter.eEntry -pady 4 -padx 4 -fill x 
pack .frControls.bStart -pady 4 -padx 4 -side left
pack .frControls.bStop -pady 4 -padx 4 -side left
pack .frControls.bClear -pady 4 -padx 4 -side left
pack .frControls.bLock -pady 4 -padx 4 -side left

pack .frOutput -side top -expand true -fill both
pack .frFilter -fill x
pack .frControls -side bottom -fill x

#####################################################################
###
###  Creating the client socket to the server.
###
#####################################################################

#set forever 0

proc ReadSocket {sid} {

	global serverSocket
	global scrollLock

	if { [gets $sid request] < 0} {
		catch {close $sid}
		set serverSocket ""
		#puts "lost connection to server."
	} else {
		#puts $request
		.frOutput.lListBox insert end $request
		if {!$scrollLock} {
			.frOutput.lListBox see end 
		}
	}
}

proc WriteSocket {args} {

	global serverSocket

	if {$serverSocket != ""} {
		puts $serverSocket $args
	}
}

set sid [socket stimpy.wg.com 9999]
fileevent $sid readable "ReadSocket $sid"
fconfigure $sid -buffering line
set serverSocket $sid




